/***************************************************************************
*   Copyright (C) 2007-2010 by Thomas Thelliez aka jblud                  *
*   Contact : <admin.kontrol@gmail.com>                                   *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as               *
*   published by the Free Software Foundation; either version 2.0 of      *
*   the License, or (at your option) any later version.                   *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU     *
*   General Public License for more details.                              *
*                                                                         *
*   You should have received a copy of the GNU General Public             *
*   License along with this program; if not, write to                     *
*   the Free Software Foundation, Inc.,                                   *
*   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA          *
***************************************************************************/

#include <QDialog>
#include <QColorDialog>
#include <QDesktopWidget>
#include <QPainter>
#include <QLineEdit>
#include <QSettings>
#include <QGridLayout>
#include <QPushButton>
#include <QCloseEvent>
#include <QLabel>
#include "../win32/qtwin.h"
#include "../../client/ui/client_main_window.h"
#include "../../server/ui/server_main_window.h"

class StartUpDialog : public QWidget
{
    Q_OBJECT

public:
    StartUpDialog();
    QLinearGradient gradientBackground;
    QPoint clickPos;
    void centerOnScreen();
private:
    void paintEvent(QPaintEvent *event);
    void mouseMoveEvent( QMouseEvent *e );
    void mousePressEvent( QMouseEvent *e );
    QSettings *settings;
public slots:
    void startClientMode();
    void startServerMode();
private:
    QPushButton *serverModeButton;
    QPushButton *clientModeButton;
};

